/* --------------------------------------------------------- */
/*	VRAM access												 */
/* ========================================================= */
/*	2006/11/26	t.hara										 */
/* --------------------------------------------------------- */

#include "msx/msx.h"

#define SCRMOD	0xFCAF		/* current screen mode */
#define	ACPAGE	0xFAF6		/* active page number */

/* --------------------------------------------------------- */
void vpeek_first( unsigned int address ) {

	if( peek( SCRMOD ) >= 7 ) {
		vdp_write_ni( 14, (address >> 14) | (peek( ACPAGE ) << 2) );
	}
	else {
		vdp_write_ni( 14, (address >> 14) | (peek( ACPAGE ) << 1) );
	}
	outport( 0x99, (unsigned char)address );
	outport( 0x99, (unsigned char)(address >> 8) & 0x3F );
}

/* --------------------------------------------------------- */
unsigned char vpeek( unsigned int address ) {
	unsigned char value;

	disable_intr();
	vpeek_first( address );
	value = inport( 0x98 );
	enable_intr();
	return value;
}
