/* --------------------------------------------------------- */
/*	VRAM access												 */
/* ========================================================= */
/*	2006/11/26	t.hara										 */
/* --------------------------------------------------------- */

#include "msx/msx.h"

#define SCRMOD	0xFCAF		/* current screen mode */
#define	ACPAGE	0xFAF6		/* active page number */

/* --------------------------------------------------------- */
void vpoke_first( unsigned int address ) {

	if( peek( SCRMOD ) >= 7 ) {
		vdp_write_ni( 14, (address >> 14) | (peek( ACPAGE ) << 2) );
	}
	else {
		vdp_write_ni( 14, (address >> 14) | (peek( ACPAGE ) << 1) );
	}
	outport( 0x99, (unsigned char)address );
	outport( 0x99, ((unsigned char)(address >> 8) & 0x7F) | 0x40 );
}

/* --------------------------------------------------------- */
void vpoke( unsigned int address, unsigned char data ) {

	disable_intr();
	vpoke_first( address );
	outport( 0x98, data );
	enable_intr();
}
