; ---------------------------------------------------------
;	Generic crt0.s for MSX-DOS, MSX-DOS2
; ---------------------------------------------------------
;	2006/11/25	t.hara	first version (base is SDCC z80/crt0.s)
;	2007/01/20	t.hara	interrupt support
; ---------------------------------------------------------

	.module	crt0
	.globl	_main

	.area	_HEADER (ABS)

	.area	_CODE

; ---------------------------------------------------------
reset_vect	= 0x0000
bdos		= 0x0005
keyint		= 0x0038

; ---------------------------------------------------------
;	MSX-DOS ̃Gg|Cg
; ---------------------------------------------------------
init:
	call	initialize_intr
	call	gsinit
	call	_main					;	main() ֐Ăяoij
	call	terminate_intr
_exit::
__clock::
	ld		c, #0					;	S DOSA
	call	bdos
	jp		reset_vect				;	Ô

; ---------------------------------------------------------
;	initialize_intr()
;	荞ݏɃtbN
; ---------------------------------------------------------
initialize_intr:
	;	keyint obNAbv
	ld		hl, #keyint
	ld		de, #backup_keyint
	ld		bc, #3
	ldir
	;	V荞ݏݒ肷
	di
	ld		a, #0xc3				;	jp intr_handler
	ld		(keyint), a
	ld		hl, #intr_handler
	ld		(keyint+1), hl
	ei
	ret

backup_keyint:
	.ds		3

; ---------------------------------------------------------
;	terminate_intr()
;	荞ݏɖ߂
; ---------------------------------------------------------
terminate_intr:
	di
	ld		hl, #backup_keyint
	ld		de, #keyint
	ld		bc, #3
	ldir
	ei
	ret

; ---------------------------------------------------------
;	intr_handler
; ---------------------------------------------------------
intr_handler:
	push	af
	push	bc
	push	de
	push	hl
	push	ix
	push	iy
	exx
	ex		af,af'
	push	af
	push	bc
	push	de
	push	hl
	push	ix
	push	iy

user_intr_handler:
	call	dummy_handler

	xor		a
	or		l
	call	z, backup_keyint

	pop		iy
	pop		ix
	pop		hl
	pop		de
	pop		bc
	pop		af
	ex		af,af'
	exx
	pop		iy
	pop		ix
	pop		hl
	pop		de
	pop		bc
	pop		af
	reti

dummy_handler:
	ret

; ---------------------------------------------------------
;	void set_interrupt_handler( char (*p_handler)( void ) )
; ---------------------------------------------------------
_set_interrupt_handler::
	ld		hl, #2
	add		hl, sp

	ld		c, (hl)
	inc		hl
	ld		b, (hl)
	di
	ld		(user_intr_handler + 1), bc
	ei
	ret

; ---------------------------------------------------------
;	eZOg
; ---------------------------------------------------------
	.area	_HOME
	.area	_CODE
	.area   _GSINIT
	.area   _GSFINAL
	.area	_DATA
	.area   _BSS
	.area   _HEAP

	.area	_CODE

; ---------------------------------------------------------
;	ltϐ̏l]郋[`
;
;	SDCCROMpRAM̕ϐ邽߂ɓfo
;	R[hNBMSX-DOSł͖ʂȃR[h
;	AoȂŒڏlĂ@킩Ȃ
; ---------------------------------------------------------
	.area   _GSINIT
gsinit::
	;	ɐ
	.area   _GSFINAL
gsfinal::
	ret
