/* --------------------------------------------------------- */
/*	VDP test												 */
/* ========================================================= */
/*	2008/05/12	t.hara										 */
/* --------------------------------------------------------- */

#include <stdio.h>
#include <msx/msx.h>

unsigned char start_time = 0;
unsigned char end_time = 0;

/* --------------------------------------------------------- */
static void test1( void ) {
	int test_time;

	_asm
		di
		/* set R#15 */
		ld		c, #0x99
		ld		a, #2
		out		(c), a
		ld		a, #0x8F
		out		(c), a
		/* wait until HR to zero */
wait_HR1:
		in		a, (c)
		and		#0x20
		jr		nz, wait_HR1
		/* wait until HR to non zero */
wait_nHR1:
		in		a, (c)
		and		#0x20
		jr		z, wait_nHR1
		/* read current system timer */
		in		a, (0xE6)
		ld		b, a
		/* wait until HR to zero */
wait_HR2:
		in		a, (c)
		and		#0x20
		jr		nz, wait_HR2
		/* read current system timer */
		in		a, (0xE6)
		/* save timer */
		ld		(_end_time), a
		ld		a, b
		ld		(_start_time), a
		/* set R#15 */
		xor		a
		out		(c), a
		ld		a, #0x8F
		out		(c), a
		ei
	_endasm;

	test_time = (int)end_time - (int)start_time;
	if( test_time < 0 ) {
		test_time += 256;
	}
	printf( "%d ", test_time );
}

/* --------------------------------------------------------- */
static void test2( void ) {
	int test_time;

	_asm
		di
		/* set R#15 */
		ld		c, #0x99
		ld		a, #2
		out		(c), a
		ld		a, #0x8F
		out		(c), a
		/* wait until VR to zero */
wait_HR3:
		in		a, (c)
		and		#0x40
		jr		nz, wait_HR1
		/* wait until VR to non zero */
wait_nHR3:
		in		a, (c)
		and		#0x40
		jr		z, wait_nHR1
		/* read current system timer */
		in		a, (0xE6)
		ld		b, a
		/* wait until VR to zero */
wait_HR4:
		in		a, (c)
		and		#0x40
		jr		nz, wait_HR2
		/* read current system timer */
		in		a, (0xE6)
		/* save timer */
		ld		(_end_time), a
		ld		a, b
		ld		(_start_time), a
		/* set R#15 */
		xor		a
		out		(c), a
		ld		a, #0x8F
		out		(c), a
		ei
	_endasm;

	test_time = (int)end_time - (int)start_time;
	if( test_time < 0 ) {
		test_time += 256;
	}
	printf( "%d ", test_time );
}

/* --------------------------------------------------------- */
int main( void ) {
	int i;

	screen( 1 );
	printf( "H BLANKING: " );
	for( i = 0; i < 10; i++ ) {
		test1();
	}
	puts( "\nPRESS RETURN" );
	printf( "V BLANKING: " );
	for( i = 0; i < 10; i++ ) {
		test2();
	}
	puts( "\nPRESS RETURN" );
	return 0;
}
