/* --------------------------------------------------------- */
/*	PSG test												 */
/* ========================================================= */
/*	2006/11/25	t.hara										 */
/* --------------------------------------------------------- */

#include <stdio.h>
#include <msx/msx.h>

/* --------------------------------------------------------- */
static const unsigned int tone_freq[] = {

	/* C4     D4     E4     F4     G4     A4     B4     C5  end mark */
	0x1AC, 0x17D, 0x153, 0x140, 0x11D, 0x0FE, 0x0E3, 0x0D6, 0,
};

/* --------------------------------------------------------- */
static void wait( int j ) {
	volatile int i;

	for( i = 0; i < j; i++ ) {
	}
}

/* --------------------------------------------------------- */
static void psg_init( void ) {
	int i;

	for( i = 0; i < 16; i++ ) {
		psg_write( i, 0 );
	}
	psg_write( 7, 0x3F );
}

/* --------------------------------------------------------- */
int main( void ) {
	int i;

	psg_init();
	psg_write( 7, 0x3E );	/* mixer */

	for( i = 0; tone_freq[i] ; i++ ) {
		printf( "tone = %03x\n", tone_freq[i] );
		psg_write( 0, (unsigned char)tone_freq[i] );			/* freq. low */
		psg_write( 1, (unsigned char)(tone_freq[i] >> 8) );		/* freq. high */
		psg_write( 8, 15 );										/* volume */
		wait( 5000 );
		psg_write( 8, 0 );										/* volume */
		wait( 1000 );
	}

	puts( "end" );
	psg_init();
	return 0;
}
