/* --------------------------------------------------------- */
/*	SPRITE test												 */
/* ========================================================= */
/*	2006/11/26	t.hara										 */
/* --------------------------------------------------------- */

#include <stdio.h>
#include <msx/msx.h>

static const unsigned char ball_pattern[] = {
	0x3C, /* 00111100 */
	0x7E, /* 01111110 */
	0xFF, /* 11111111 */
	0xFF, /* 11111111 */
	0xFF, /* 11111111 */
	0xFF, /* 11111111 */
	0x7E, /* 01111110 */
	0x3C  /* 00111100 */
};

int x[32];
int y[32];
int vx[32];
int vy[32];

/* --------------------------------------------------------- */
static void wait( int j ) {
	volatile int i;

	for( i = 0; i < j; i++ ) {
	}
}

/* --------------------------------------------------------- */
int main( void ) {
	int i, j;

	screen( 1 );
	set_sprite_pattern( 0, ball_pattern );

	/* init */
	printf( "init ... " );
	for( i = 0; i < 32; i++ ) {
		x[i] = (i * 37 + 5) & 255;
		y[i] = (i * 19 + 7) % 212;
		vx[i] = (((i * 23) & 1) << 3) - 4;
		vy[i] = (((i * 57) & 1) << 3) - 4;
	}
	printf( "ok\n" );

	/* loop */
	for( j = 0; j < 10000; j++ ) {
		for( i = 0; i < 32; i++ ) {
			put_sprite( i, x[i], y[i], 0, (i & 7) + 8 );

			x[i] = x[i] + vx[i];
			if( x[i] > 255 ) {
				x[i] = 255;
				vx[i] = -vx[i];
			}
			else if( x[i] < 0 ) {
				x[i] = 0;
				vx[i] = -vx[i];
			}

			y[i] = y[i] + vy[i];
			if( y[i] > 211 ) {
				y[i] = 211;
				vy[i] = -vy[i];
			}
			else if( y[i] < 0 ) {
				y[i] = 0;
				vy[i] = -vy[i];
			}
		}
	}
	return 0;
}
